import java.util.*;

public class SelectionSortTest
{
	 public static int smallestInRange(double[] data, int lo, int hi)
	    {
			int iSmallest = lo;
			for (int i=lo; i<=hi; i++)
				if (data[i] < data[iSmallest])
					iSmallest = i;
			return iSmallest;
	    }


    public static void selectionSort(double[] data)
    {
		/* Note the bounds - why don't go all the way to data.length - 1 ? */
        for (int i=0; i<data.length-1; i++)
		{
		    int iSmallest = smallestInRange(data,i,data.length-1);

		    /* Swap values */
		    if (i < iSmallest) {
            	double temp = data[i];
            	data[i] = data[iSmallest];
            	data[iSmallest] = temp;
		    }
		    System.out.print("Step " + (i+1) + ":   ");
		    print(data);
		}
    }
	
	public static void print(double[] data) {
		for (int i = 0; i < data.length; i++) 
			System.out.print(data[i] + "\t" );
		System.out.println();
	}
	
	public static boolean isSorted(double[] data) {
		boolean bool = true;
		if (data.length == 0) return bool;
		for (int i = 1; i < data.length; i++) 
			if (data[i-1] > data[i]) return false;
		return bool;
	}

    public static void main(String[] args)
    {
		//double[] data = {12.0,};
		//double[] data = {};
		//double[] data = {5.0, 0.0, 12.7, -2.3, -0.3, 7.0, 1.2, -7.1};
		//double[] data = {-7.1, 0.0, 12.7, -2.3, -0.3, 7.0, 1.2, 5.0};
		double[] data = {5.0, 7.0, -0.3, 0.0, 1.2,-7.1, -2.3,  12.7};
		
		
		System.out.println("Is the array sorted? " + isSorted(data));
		System.out.println("Original array: ");
		print(data);

		selectionSort(data);
		System.out.println("Is the array sorted? " + isSorted(data));
		
		System.out.println("Sorted array");
		print(data);
    }
}
